% An iterative deepening interpreter.

module idfs.

import lists maptac.

type app_tac            list (goal -> goal -> o) -> goal -> goal -> o.
type idfs               int -> int -> list (goal -> goal -> o)
                          -> goal -> goal -> o.
type idfs_interpb       int -> int -> int -> list (goal -> goal -> o)
                          -> goal -> o.
type idfs_interp        int -> int -> list (goal -> goal -> o) -> goal -> o.

app_tac (Tac::T) InGoal OutGoal :- Tac InGoal OutGoal.
app_tac (Tac::T) InGoal OutGoal :- app_tac T InGoal OutGoal.

idfs Bnd N Tacs InGoal OutGoal :-
  N =< Bnd,
  app_tac Tacs InGoal MidGoal,
  M is (N + 1),
  maptac (idfs Bnd M Tacs) MidGoal OutGoal.

idfs_interpb Bnd Incr UpBnd Tacs InGoal :-
  maptac (idfs Bnd 1 Tacs) InGoal OutGoal.
idfs_interpb Bnd Incr UpBnd Tacs InGoal :-
  Bnd1 is (Bnd + Incr), Bnd1 =< UpBnd,
  idfs_interpb Bnd1 Incr UpBnd Tacs InGoal.

idfs_interp Bnd Incr Tacs InGoal :- maptac (idfs Bnd 1 Tacs) InGoal OutGoal.
idfs_interp Bnd Incr Tacs InGoal :- Bnd1 is (Bnd + Incr),
                                    idfs_interp Bnd1 Incr Tacs InGoal.


%incr_bound Bnd UpBnd Tacs InGoal :- Bnd1 is (Bnd + 1),
%                                    Bnd =< UpBnd,
%                                    idfs_interp Bnd1 UpBnd Tacs InGoal.

%idfs_interp Bnd UpBnd Tacs InGoal :- maptac (idfs Bnd 1 Tacs) InGoal OutGoal.
%idfs_interp Bnd UpBnd Tacs InGoal :- incr_bound Bnd UpBnd Tacs InGoal.
