module nprf.

%  This file is the "signature" file for building proofs in
%  a natural deduction setting.
%  Proofs include substitution instances and some formulas inside proofs.
%  There are two constants for or-introduction and and-elimination.

import  fol.

kind    nprf        type.

type    and_i       nprf -> nprf -> nprf.
type    and_e1      form -> nprf -> nprf.
type    and_e2      form -> nprf -> nprf.
type    or_i1       nprf -> nprf.
type    or_i2       nprf -> nprf.
type    or_e        form -> form -> nprf ->
                      (nprf -> nprf) -> (nprf -> nprf) -> nprf.
type    imp_i       (nprf -> nprf) -> nprf.
type    imp_e       form -> nprf -> nprf -> nprf.
type    neg_i       (nprf -> nprf) -> nprf.
type    neg_e       form -> nprf -> nprf -> nprf.
type    exists_i    i -> nprf -> nprf.
type    exists_e    (i -> form) -> nprf -> (i -> nprf -> nprf) -> nprf.
type    forall_i    (i -> nprf) -> nprf.
type    forall_e    i -> (i -> form) -> nprf -> nprf.
type    false_i     nprf -> nprf.
type    false_c     (nprf -> nprf) -> nprf.
